.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\masm32.inc
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\masm32.lib

wsprintfA PROTO C :DWORD,:VARARG
wsprintf equ <wsprintfA>

pusho MACRO param
push OFFSET param
ENDM

.data
template1   db 'EXTERNDEF %s@%u:proc',13,10
            db '%s equ <stcall %s@%d,%d>',13,10,13,10,0
template2   db 'EXTERNDEF %s:proc',13,10
            db '_%s equ <%s %s,%d>',13,10,13,10,0
message     db 'MASM include file converter V1.0',13,10
            db 'for function call without using the invoke statement',13,10,13,10
            db 'usage : convinc incfile.inc [-w]',13,10
            db 'Optional : -w for UNICODE',0
nofile      db 'File not found',0
type1	    db 'ccall',0
type2	    db 'ccallva',0
b1	    db 87
b2	    db 65

.data?
wfd             WIN32_FIND_DATA <?>
temp            db 512 dup(?)
cmdlineparam    db 256 dup(?)
cmdlineparam2   db 256 dup(?)
cmdlineparam3   db 256 dup(?)
cmdlineparam4	db 128 dup(?)
name2           db 256 dup(?)
buffer          dd ?
hFile           dd ?
size1           dd ?
hInc            dd ?
hWfd            dd ?
eof             dd ?
funcname        dd ?
dwordcount      dd ?
flag            dd ?
flag2           dd ?
startln		dd ?
endln		dd ?

.code
start:
        invoke ArgClC,1,ADDR cmdlineparam
        mov al,BYTE PTR [cmdlineparam]
        or al,al
        jnz @f
        invoke StdOut,ADDR message
        jmp finish
@@:	
	invoke ArgClC,2,ADDR cmdlineparam4
	mov ax,WORD PTR [cmdlineparam4]
	cmp ax,'w-'
	jne @f
	mov b1,65
	mov b2,87
@@:        
	invoke FindFirstFile,ADDR cmdlineparam,ADDR wfd
        mov hWfd,eax
        cmp eax,INVALID_HANDLE_VALUE
        jne @f
        invoke StdOut,ADDR nofile
        jmp finish
@@:
	invoke lstrcpy,ADDR cmdlineparam3,ADDR cmdlineparam
	invoke lstrlen,ADDR cmdlineparam3
        lea edx,[cmdlineparam3+eax-1]
@@:
        cmp BYTE PTR [edx],92
        jz @f
        dec edx
        dec eax
        jnz @b
@@:
        lea eax,[cmdlineparam3+eax]
	mov endln,eax
        pusho cmdlineparam3
	pop startln
restart:
        mov eax,endln
        mov BYTE PTR [eax],0
	invoke lstrcpy,ADDR cmdlineparam2,ADDR wfd.cFileName
	invoke lstrcat,startln,ADDR cmdlineparam2
	invoke CreateFile,startln,GENERIC_READ,\
               0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,0
@@:
        mov hInc,eax
        mov eax,wfd.nFileSizeLow
        push eax
        add eax,2
        invoke GlobalAlloc,GPTR,eax
        mov buffer,eax 
        invoke ReadFile,hInc,eax,wfd.nFileSizeLow,ADDR size1,0
        invoke CloseHandle,hInc
	mov esi,buffer
        pop eax
        lea eax,[esi+eax-2]
        cmp DWORD PTR [eax],2573
	jz @f
	add eax,2
        mov DWORD PTR [eax],2573
@@:
	mov eof,eax
        invoke CreateFile,ADDR cmdlineparam2,GENERIC_WRITE,\
               0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0
        mov hFile,eax
        push esi
        push edi
        push ebx
start0:
        mov funcname,esi
        mov dwordcount,0
start1:
        cmp DWORD PTR [esi],'TORP'
        jne endline
        push esi
        push esi
        mov esi,funcname
@@:
        inc esi
        mov al,BYTE PTR [esi-1]
        cmp al,32
        je @b
        cmp al,9
        je @b
        lea eax,[esi-1]
        mov funcname,eax
        pop esi
@@:
        dec esi
        mov al,BYTE PTR [esi]
        cmp al,32
        je @b
        cmp al,9
        je @b
        mov BYTE PTR [esi+1],0
        pop esi
        add esi,5
        cmp BYTE PTR [esi+1],'C'
        jne fndword
        mov flag,1
fndword:
        cmp DWORD PTR [esi],'ROWD'
        jne @f
        add esi,5
        inc dwordcount
@@:
        cmp DWORD PTR [esi],'RAV:'        
        jne @f
        mov flag2,1
        add esi,7
@@:
        cmp WORD PTR [esi],2573
        jz @f
        inc esi
        jmp fndword
@@:
        invoke lstrcpy,ADDR name2,funcname
        invoke lstrlen,ADDR name2
        lea eax,[name2+eax-1]
        mov cl,BYTE PTR [eax]
	cmp cl,b1
        je endfile
        cmp cl,b2
        jne @f
        mov BYTE PTR [eax],0
@@:
	mov ecx,dwordcount
        mov ebx,ecx
        shl ecx,2
        mov edx,flag
        or edx,edx            
        jz notcfunc
	push ebx
	push funcname
	cmp flag2,1
	je @f
	pusho type1
	jmp l1
@@:
	pusho type2
	mov flag2,0
l1:
	pusho name2
	push funcname
	pusho template2
	pusho temp
	call wsprintf
	add esp,28 
        call write_file
        mov flag,0
        jmp endfile
notcfunc:
        invoke wsprintf,ADDR temp,ADDR template1,funcname,ecx,ADDR name2,\
                        funcname,ecx,ebx
        call write_file
        jmp endfile
       
endline:
        cmp WORD PTR [esi],2573
        jz endfile
        inc esi
        jmp start1
endfile:
        cmp esi,eof
        jz @f
        add esi,2
        jmp start0
@@:
        invoke CloseHandle,hFile
        pop ebx
        pop edi
        pop esi
        invoke GlobalFree,buffer
        invoke FindNextFile,hWfd,ADDR wfd
        or eax,eax
        jz @f
        jmp restart
@@:
        invoke FindClose,hWfd
finish:
        invoke ExitProcess,0

write_file PROC
        invoke WriteFile,hFile,ADDR temp,eax,ADDR size1,0
        ret
write_file ENDP

END start
